/*(c)y2k malekith
malekith@cnc.pl, malekith@topnet.pl
include gnu.gpl
motto: you may write a game from 00:40 to 01:49 ...
*/

/*config*/
#define W 10
#define H 18
#define SPC '.'
#define SPC2 ' '
#define KLOC '%'
#define KLOCE "[]","{}","()","<>"
#define WALL '#'
#define SPEED 10
/*end of config*/

#ifdef NN
#include<ncurses/ncurses.h>
#else
#include<curses.h>
#endif

#define ww(n) write(fd, &n, sizeof (n))
#define rr(n) read(fd, &n, sizeof (n))

int k[][4]={{0xe400,0x4c40,0x4e00,0x8c80},{0x8888,0xf000,0x8888,0xf000},
{0x6c00,0x8c40,0x6c00,0x8c40},{0xc600,0x4c80,0xc600,0x4c80},
{0xcc00,0xcc00,0xcc00,0xcc00},{0xc880,0xe200,0x44c0,0x8e00},
{0xc440,0x2e00,0x88c0,0xe800}},m[W][H],x,y,n,p,tm,lev,pts,lns,paused,
kloc1,kloc2;char *kloce[]={KLOCE};

wr(char *fn)
{int magic=0x5afe6666,fd=creat(fn,0666);if(fd<0){perror(fn);return;}
ww(magic);ww(tm);ww(lev);ww(pts);ww(lns);write(fd,m,sizeof m);close(fd);
}

rd(char *fn)
{int magic,fd=open(fn,0);if(fd<0){perror(fn);exit(0);}
rr(magic);if(magic!=0x5afe6666){printf("%s: not a savegame\n",fn);exit(0);}
rr(tm);rr(lev);rr(pts);rr(lns);read(fd,m,sizeof m);;close(fd);
}


ch()
{int i,j,d;int*v=m[0];
for(i=W*H;i-->0;v++)if(*v!=WALL)*v=SPC;
for(d=k[n][p],i=0;i<4;i++){for(j=0;j<4;j++,d<<=1)
if(d&0x8000)if(x+j>=W||x+j<0||y+i>=H||m[x+j][y+i]==WALL)return 0;
else m[x+j][y+i]=KLOC;}return 1;}

dp()
{char buf[100];
sprintf(buf,"P0inTZ: %08d   [ln:%d]    Lef: %d    ([q]-quit, [p]-pause, "
"[w]-write)",pts,lns,lev);
move(H+4,1);addstr(buf);
move(H+5,1);addstr(paused?"[paused]":"        ");
}

dr()
{int i,j;
for(i=0;i<H;i++){
move(i+1,(80-W*2)/2-1);addch('|');
for(j=0;j<W;j++)
switch(m[j][i]){case SPC:addch(SPC);addch(SPC2);break;
case KLOC:addch(kloc1);addch(kloc2);break;
default:addch(m[j][i]);addch(m[j][i]);break;}
addstr("||");}
move(i+1,(80-W*2)/2-1);addch('L');for (j = 0;j<W;j++)addstr("_L");
addch('|');addch('/');dp();refresh();}

bnd()
{
int i,j,k;pts+=6+3*lev;
for(i=0;i<H;i++){
int all=1;
for(j=0;j<W;j++)if(m[j][i]==KLOC)m[j][i]=WALL;else if(m[j][i]==SPC)all=0;
if(all){for(j=0;j<W;j++)for(k=i;k>0;k--)m[j][k]=m[j][k-1];m[j][0]=SPC;
lns++;if(lns%10==0)lev++;pts+=666+25*lev;}}
}

main(int argc,char**argv){
int down=0,last_down=0,one_dn=0,dead=0,c;char *pn=*argv;
srand(getpid()^time(0));
{char*k=kloce[rand()%(sizeof(kloce)/sizeof(kloce[0]))];kloc1=k[0];kloc2=k[1];}
if(*++argv)rd(*argv);
initscr();noecho();cbreak();timeout(0);keypad(stdscr,TRUE);
while(!dead){y=0;x=W/2-1;n=rand()%(sizeof(k)/sizeof(k[0]));p=0;if(!ch())break;
while(!dead){
if(!paused&&one_dn||down||tm-last_down>(lev<20?30-lev:10))
{one_dn=0;y++;last_down=tm;if(!ch()){y--;ch();bnd();down=0;break;}}
ch();dr();c=getch();if(c>='A'&&c<='Z')c|=0x20;
switch(c){
case ERR:case 0:default:break;
case KEY_LEFT:case ',':if(!paused&&x>0){x--;if(!ch())x++;}break;
case KEY_RIGHT:case '.':if(!paused&&x<W-1){x++;if(!ch())x--;}break;
case KEY_DOWN:case ';':case 'm':one_dn=1;break;
case ' ':down=1;break;
case KEY_UP:case '/':case 'l':p++;p&=0x3;
if(!ch()&&x>0){x--;if(!ch())x++;}if(!ch()){p--;p&=0x3;}break;
case 'q':dead=1;break;case 'p':paused=!paused;break;
case 'w':{char fn[100];move(1,1);addstr("save name: ");timeout(-1);echo();
getnstr(fn,100);timeout(0);noecho();wr(fn);move(2,1);addstr("to load type ");
addstr(pn);addstr(" ");addstr(fn);refresh();}break;
case 12:wrefresh(curscr);break;
}usleep(SPEED*1000);if(!paused)tm++;}}
endwin();
printf(
"      [ ya may share dedris with ya friends and modify it under GNU GPL ]
      [ ......--------=======> %08d points ! <=======--------...... ]
      [ thank ya for playin' dedris / by malekith <malekith@topnet.pl>  ]
",pts);

}
